"""Add settings storage

Revision ID: 5e3ef47c70a1
Revises: 771be83a8b87
Create Date: 2020-02-08 22:40:53.472351

"""
import sqlalchemy as sa

from alembic import op

# revision identifiers, used by Alembic.
revision = "5e3ef47c70a1"
down_revision = "771be83a8b87"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "settings",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("name", sa.Text(), nullable=True),
        sa.Column("value", sa.Text(), nullable=True),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_index(op.f("ix_settings_id"), "settings", ["id"], unique=False)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_settings_id"), table_name="settings")
    op.drop_table("settings")
    # ### end Alembic commands ###
